--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
Entity Configurable_U_CHAR Is
  Port(
      CLK : in    std_logic;
      CLK_CAP : in    std_logic;
      EXT_TRIGGER : in    std_logic;
      CHAR : in   std_logic_vector(7 downto 0);
      STATUS : out   std_logic;
      TCK : in   std_logic;
      TDI : in   std_logic;
      TDO : out   std_logic;
      TMS : in   std_logic;
      TRST : in   std_logic
      );
End Configurable_U_CHAR;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
Architecture structure of Configurable_U_CHAR is

   Component LAX_CFG8
      port
      (
        CH_TRIG  : in  STD_LOGIC_VECTOR(7 downto 0);
        CH_CAP   : in  STD_LOGIC_VECTOR(7 downto 0);
        CLK      : in  STD_LOGIC;
        CLK_CAP  : in  STD_LOGIC;
        STATUS   : out STD_LOGIC;
        DATAO    : out STD_LOGIC_VECTOR(7 downto 0);
        DATAI    : in  STD_LOGIC_VECTOR(7 downto 0);
        ADDR     : out STD_LOGIC_VECTOR(19 downto 0);
        WR       : out STD_LOGIC;
        RD       : out STD_LOGIC;
        SEL_CAP  : out STD_LOGIC_VECTOR(3 downto 0);
        SEL_TRIG : out STD_LOGIC_VECTOR(3 downto 0);
        TCK      : in  STD_LOGIC;
        TDI      : in  STD_LOGIC;
        TDO      : out STD_LOGIC;
        TMS      : in  STD_LOGIC;
        TRIGGER  : in  STD_LOGIC;
        TRST     : in  STD_LOGIC
      );
   End Component;

   Component memory_u_char
      port
      (
        CLK      : in  STD_LOGIC;
        WE       : in  STD_LOGIC;
        ADDR     : in  STD_LOGIC_VECTOR(9 downto 0);
        DIN      : in  STD_LOGIC_VECTOR(7 downto 0);
        DOUT     : out STD_LOGIC_VECTOR(7 downto 0)
      );
   End Component;

   Signal Unique_Lax_Signal_Name_Mem_WE   : STD_LOGIC;
   Signal Unique_Lax_Signal_Name_Mem_DIN  : STD_LOGIC_VECTOR(7 downto 0);
   Signal Unique_Lax_Signal_Name_Mem_DOUT : STD_LOGIC_VECTOR(7 downto 0);

   Signal Unique_Lax_Signal_Name_Mem_ADDR : STD_LOGIC_VECTOR(19 Downto 0);
   Signal Unique_Lax_Signal_Name_selcap   : STD_LOGIC_VECTOR(3 downto 0);
   Signal Unique_Lax_Signal_Name_seltrig  : STD_LOGIC_VECTOR(3 downto 0);
   Signal Unique_Lax_Signal_Name_capin    : STD_LOGIC_VECTOR(7 downto 0);
   Signal Unique_Lax_Signal_Name_trigin   : STD_LOGIC_VECTOR(7 downto 0);


Begin
    Unique_Lax_Signal_Name_capin(0) <= CHAR(0);
    Unique_Lax_Signal_Name_trigin(0) <= CHAR(0);
    Unique_Lax_Signal_Name_capin(1) <= CHAR(1);
    Unique_Lax_Signal_Name_trigin(1) <= CHAR(1);
    Unique_Lax_Signal_Name_capin(2) <= CHAR(2);
    Unique_Lax_Signal_Name_trigin(2) <= CHAR(2);
    Unique_Lax_Signal_Name_capin(3) <= CHAR(3);
    Unique_Lax_Signal_Name_trigin(3) <= CHAR(3);
    Unique_Lax_Signal_Name_capin(4) <= CHAR(4);
    Unique_Lax_Signal_Name_trigin(4) <= CHAR(4);
    Unique_Lax_Signal_Name_capin(5) <= CHAR(5);
    Unique_Lax_Signal_Name_trigin(5) <= CHAR(5);
    Unique_Lax_Signal_Name_capin(6) <= CHAR(6);
    Unique_Lax_Signal_Name_trigin(6) <= CHAR(6);
    Unique_Lax_Signal_Name_capin(7) <= CHAR(7);
    Unique_Lax_Signal_Name_trigin(7) <= CHAR(7);

    U1 : LAX_CFG8
      Port Map
      (
        CH_CAP    => Unique_Lax_Signal_Name_capin,
        CH_TRIG   => Unique_Lax_Signal_Name_trigin,
        CLK      => CLK,
        CLK_CAP  => CLK_CAP,
        STATUS   => STATUS,
        DATAO    => Unique_Lax_Signal_Name_Mem_DIN,
        DATAI    => Unique_Lax_Signal_Name_Mem_DOUT,
        WR       => Unique_Lax_Signal_Name_Mem_WE,
        RD       => Open,
        ADDR     => Unique_Lax_Signal_Name_Mem_ADDR,
        SEL_CAP  => Unique_Lax_Signal_Name_selcap,
        SEL_TRIG => Unique_Lax_Signal_Name_seltrig,
        TCK      => TCK,
        TDI      => TDI,
        TDO      => TDO,
        TMS      => TMS,
        TRIGGER  => EXT_TRIGGER,
        TRST     => TRST
      );
    U2 : memory_u_char
      Port Map
      (
        CLK      => CLK,
        DIN      => Unique_Lax_Signal_Name_Mem_DIN,
        DOUT     => Unique_Lax_Signal_Name_Mem_DOUT,
        ADDR     => Unique_Lax_Signal_Name_Mem_ADDR(9 Downto 0),
        WE       => Unique_Lax_Signal_Name_Mem_WE
      );

End structure;
--------------------------------------------------------------------------------
